## Literature

Newly created page to list related references and additional literature pertaining to this package.

### Direct References

[1.1]  Fourie, D., Leonard, J., Kaess, M.: ["A Nonparametric Belief Solution to the Bayes Tree"](http://www.ri.cmu.edu/pub_files/2016/10/Fourie16iros.pdf) IEEE/RSJ Intl. Conf. on Intelligent Robots and Systems (IROS), (2016).

[1.2]  Fourie, D.: ["Multi-modal and Inertial Sensor Solutions for Navigation-type Factor   Graphs"](https://darchive.mblwhoilibrary.org/bitstream/handle/1912/9305/Fourie_thesis.pdf?sequence=1), Ph.D. Thesis, Massachusetts Institute of Technology Electrical Engineering and Computer Science together with Woods Hole Oceanographic Institution Department for Applied Ocean Science and Engineering, September 2017.

[1.3]  Fourie, D., Claassens, S., Pillai, S., Mata, R., Leonard, J.: ["SLAMinDB: Centralized graph databases for mobile robotics"](http://people.csail.mit.edu/spillai/projects/cloud-graphs/2017-icra-cloudgraphs.pdf), IEEE Intl. Conf. on Robotics and Automation (ICRA), Singapore, 2017.

[1.4]  Cheung, M., Fourie, D., Rypkema, N., Vaz Teixeira, P., Schmidt, H., and Leonard, J.: ["Non-Gaussian SLAM utilizing Synthetic Aperture Sonar"](https://marinerobotics.mit.edu/sites/default/files/cheung_icra2019.pdf), Intl. Conf. On Robotics and Automation (ICRA), IEEE, Montreal, 2019.

[1.5]  Doherty, K., Fourie, D., Leonard, J.: ["Multimodal Semantic SLAM with Probabilistic Data Association"](https://marinerobotics.mit.edu/sites/default/files/doherty_icra2019_revised.pdf), Intl. Conf. On Robotics and Automation (ICRA), IEEE, Montreal, 2019.

[1.6]  Fourie, D., Vaz Teixeira, P., Leonard, J.: ["Non-parametric Mixed-Manifold Products using Multiscale Kernel Densities"](https://marinerobotics.mit.edu/sites/default/files/fourie_iros19_manifolds.pdf), IEEE Intl. Conf. on Intelligent Robots and Systems (IROS), (2019),.

[1.7]  Teixeira, P.N.V., Fourie, D., Kaess, M. and Leonard, J.J., 2019, September. ["Dense, sonar-based reconstruction of underwater scenes"](https://www.cs.cmu.edu/~kaess/pub/Teixeira19iros.pdf). In 2019 IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS) (pp. 8060-8066). IEEE.

[1.8]  Fourie, D., Leonard, J.: "Inertial Odometry with Retroactive Sensor Calibration", 2015-2019.

[1.9] Koolen, T. and Deits, R., 2019. Julia for robotics: Simulation and real-time control in a high-level programming language. IEEE, Intl. Conference on Robotics and Automation, ICRA (2019).

[1.10] Fourie, D., Espinoza, A. T., Kaess, M., and Leonard, J. J., [“Characterizing marginalization and incremental operations on the Bayes tree,”](http://robotics.cs.rutgers.edu/wafr2020/wp-content/uploads/sites/7/2020/05/WAFR_2020_FV_28.pdf) in International Workshop on Algorithmic Foundations of Robotics (WAFR), 2020, Oulu, Finland, Springer Publishing.

[1.11] Fourie, D., Rypkema, N., Claassens, S., Vaz Teixeira, P., Fischell, E., and Leonard, J.J., ["Towards Real-Time Non-Gaussian SLAM for Underdetermined Navigation"](http://ras.papercept.net/images/temp/IROS/files/2648.pdf), in IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS), October 2020, Las Vegas, USA.

[1.12] J. Terblanche, S. Claassens and D. Fourie, ["Multimodal Navigation-Affordance Matching for SLAM,"](http://www.navability.io/wp-content/uploads/2021/08/NavAbility_RAL2021_preprint.pdf) in IEEE Robotics and Automation Letters, vol. 6, no. 4, pp. 7728-7735, Oct. 2021, doi: 10.1109/LRA.2021.3098788.  Also presented at, IEEE 17th International Conference on Automation Science and Engineering, August 2021, Lyon, France.

### Important References

[2.1]  Kaess, Michael, et al. ["iSAM2: Incremental smoothing and mapping using the Bayes tree"](http://journals.sagepub.com/doi/abs/10.1177/0278364911430419) The International Journal of Robotics Research (2011): 0278364911430419.

[2.2]  Kaess, Michael, et al. ["The Bayes tree: An algorithmic foundation for probabilistic robot mapping."](https://smartech.gatech.edu/bitstream/handle/1853/38459/Kaess10wafr.pdf?sequence=1&isAllowed=y) Algorithmic Foundations of Robotics IX. Springer, Berlin, Heidelberg, 2010. 157-173.

[2.3]  Kschischang, Frank R., Brendan J. Frey, and Hans-Andrea Loeliger. ["Factor graphs and the sum-product algorithm."](http://www.cs.utoronto.ca/~radford/csc2506/factor.pdf) IEEE Transactions on information theory 47.2 (2001): 498-519.

[2.4]  Dellaert, Frank, and Michael Kaess. ["Factor graphs for robot perception."](https://www.nowpublishers.com/article/DownloadSummary/ROB-043) Foundations and Trends® in Robotics 6.1-2 (2017): 1-139.

[2.5]  Sudderth, E.B., Ihler, A.T., Isard, M., Freeman, W.T. and Willsky, A.S., 2010. ["Nonparametric belief propagation."](https://www.microsoft.com/en-us/research/wp-content/uploads/2010/10/p95-sudderth.pdf) Communications of the ACM, 53(10), pp.95-103

[2.6]  Paskin, Mark A. ["Thin junction tree filters for simultaneous localization and mapping."](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.15.7602&rep=rep1&type=pdf) in Int. Joint Conf. on Artificial Intelligence. 2003.

[2.7]  Farrell, J., and Matthew B.: "The global positioning system and inertial navigation." Vol. 61. New York: Mcgraw-hill, 1999.

[2.8]  Zarchan, Paul, and Howard Musoff, eds. Fundamentals of Kalman filtering: a practical approach. American Institute of Aeronautics and Astronautics, Inc., 2013.

[2.9]  Rypkema, N. R.,: ["Underwater & Out of Sight: Towards Ubiquity in UnderwaterRobotics"](http://dspace.mit.edu/bitstream/handle/1721.1/124118/1142630448-MIT.pdf), Ph.D. Thesis, Massachusetts Institute of Technology Electrical Engineering and Computer Science together with Woods Hole Oceanographic Institution Department for Applied Ocean Science and Engineering, September 2019.

[2.10] Vaz Teixeira, P.: ["Dense, Sonar-based Reconstruction of Underwater Scenes"](http://dspace.mit.edu/bitstream/handle/1721.1/123776/1139519986-MIT.pdf), Ph.D. Thesis, Massachusetts Institute of Technology Electrical Engineering and Computer Science together with Woods Hole Oceanographic Institution Department for Applied Ocean Science and Engineering, September 2019.

[2.11] Hanebeck, Uwe D. ["FLUX: Progressive State Estimation Based on Zakai-type Distributed Ordinary Differential Equations."](https://arxiv.org/pdf/1808.02825) arXiv preprint arXiv:1808.02825 (2018).

[2.12] Muandet, Krikamol, et al. ["Kernel mean embedding of distributions: A review and beyond."](https://www.nowpublishers.com/article/DownloadSummary/MAL-060) Foundations and Trends® in Machine Learning 10.1-2 (2017): 1-141.

[2.13] Hsiao, M. and Kaess, M., 2019, May. "MH-iSAM2: Multi-hypothesis iSAM using Bayes Tree and Hypo-tree". In 2019 International Conference on Robotics and Automation (ICRA) (pp. 1274-1280). IEEE.

[2.14] Arnborg, S., Corneil, D.G. and Proskurowski, A., 1987. ["Complexity of finding embeddings in a k-tree"](https://epubs.siam.org/doi/pdf/10.1137/0608024). SIAM Journal on Algebraic Discrete Methods, 8(2), pp.277-284.

[2.15a] Sola, J., Deray, J. and Atchuthan, D., 2018. ["A micro Lie theory for state estimation in robotics". arXiv preprint arXiv:1812.01537](https://arxiv.org/pdf/1812.01537), and [tech report](https://upcommons.upc.edu/bitstream/handle/2117/179757/2089-A-micro-Lie-theory-for-state-estimation-in-robotics%20(3).pdf).

[2.15b] Delleart F., 2012. [Lie Groups for Beginners](https://raw.githubusercontent.com/devbharat/gtsam/master/doc/LieGroups.pdf).

[2.15c] Eade E., 2017 [Lie Groups for 2D and 3D Transformations](https://ethaneade.com/lie.pdf).

[2.15d] Chirikjian, G.S., 2015. [Partial bi-invariance of SE(3) metrics](https://rpk.lcsr.jhu.edu/wp-content/uploads/2017/08/Partial-Bi-Invariance-of-SE3-Metrics1.pdf). Journal of Computing and Information Science in Engineering, 15(1).

[2.15e] Pennec, X. and Lorenzi, M., 2020. [Beyond Riemannian geometry: The affine connection setting for transformation groups](https://hal.inria.fr/hal-02342137/document). In Riemannian Geometric Statistics in Medical Image Analysis (pp. 169-229). Academic Press.

[2.15f] Žefran, M., Kumar, V. and Croke, C., 1996, August. [Choice of Riemannian metrics for rigid body kinematics](https://www.cis.upenn.edu/~cis610/SE3-Croke-Kumar.pdf). In International Design Engineering Technical Conferences and Computers and Information in Engineering Conference (Vol. 97584, p. V02BT02A030). American Society of Mechanical Engineers.

[2.15g] Chirikjian, G.S. and Zhou, S., 1998. [Metrics on motion and deformation of solid models](https://asmedigitalcollection.asme.org/mechanicaldesign/article-abstract/120/2/252/429661/Metrics-on-Motion-and-Deformation-of-Solid-Models).

[2.16] Kaess, M. and Dellaert, F., 2009. [Covariance recovery from a square root information matrix for data association](https://apps.dtic.mil/dtic/tr/fulltext/u2/a537233.pdf). Robotics and autonomous systems, 57(12), pp.1198-1210.

[2.17] Bishop, C.M., 2006. Pattern recognition and machine learning. New York: Springer. ISBN 978-0-387-31073-2.

### Additional References

[3.1]  Duits, Remco, Erik J. Bekkers, and Alexey Mashtakov. ["Fourier Transform on the Homogeneous Space of 3D Positions and Orientations for Exact Solutions to Linear Parabolic and (Hypo-) Elliptic PDEs".](https://www.preprints.org/manuscript/201811.0027/download/final_file) arXiv preprint arXiv:1811.00363 (2018).

[3.2]  Mohamed, S., Rosca, M., Figurnov, M. and Mnih, A., 2019. ["Monte carlo gradient estimation in machine learning". arXiv preprint arXiv:1906.10652](https://arxiv.org/pdf/1906.10652).

[3.3]  Rackauckas, C., Ma, Y., Martensen, J., Warner, C., Zubov, K., Supekar, R., Skinner, D., Ramadhan, A., Edelman, A., ["Universal Differential Equations for Scientific Machine Learning"](https://arxiv.org/abs/2001.04385), Archive online, DOI: 2001.04385.

[3.4]  Boumal, Nicolas. [An introduction to optimization on smooth manifolds. Available online](http://sma.epfl.ch/~nboumal/book/index.html), May, 2020.

[3.5]  [Relationship between the Hessianand Covariance Matrix forGaussian Random Variables, John Wiley & Sons](https://onlinelibrary.wiley.com/doi/pdf/10.1002/9780470824566.app1)

[3.6]  Pennec, Xavier. [Intrinsic Statistics on Riemannian Manifolds: Basic Tools for Geometric Measurements, HAL Archive](https://hal.inria.fr/inria-00614994/PDF/Pennec.JMIV06.pdf), 2011, Inria, France.

[3.7]  Weber, P., Medina-Oliva, G., Simon, C., et al., 2012. Overview on Bayesian networks applications for dependability risk analysis and maintenance areas. Appl. Artif. Intell. 25 (4), 671e682. [https://doi.org/10.1016/j.engappai.2010.06.002](https://doi.org/10.1016/j.engappai.2010.06.002). [Preprint PDF](https://hal.archives-ouvertes.fr/hal-00546144/file/Draft_00_Weber_eaai_2010.pdf).

[3.8]  Wang, H.R., Ye, L.T., Xu, X.Y., et al., 2010. Bayesian networks precipitation model based on hidden markov analysis and its application. Sci. China Technol. Sci. 53 (2), 539e547. [https://doi.org/10.1007/s11431-010-0034-3](https://doi.org/10.1007/s11431-010-0034-3).

[3.9]  Mangelson, J.G., Dominic, D., Eustice, R.M. and Vasudevan, R., 2018, May. [Pairwise consistent measurement set maximization for robust multi-robot map merging](http://141.212.194.179/publications/jmangelson-2018a.pdf). In 2018 IEEE international conference on robotics and automation (ICRA) (pp. 2916-2923). IEEE.

[3.10] Bourgeois, F. and Lassalle, J.C., 1971. [An extension of the Munkres algorithm for the assignment problem to rectangular matrices](https://dl.acm.org/doi/pdf/10.1145/362919.362945). Communications of the ACM, 14(12), pp.802-804.

### Signal Processing (Beamforming and Channel Deconvolution)

[4.1]  Van Trees, H.L., 2004. Optimum array processing: Part IV of detection, estimation, and modulation theory. John Wiley & Sons.

[4.2a]  Dowling, D.R., 2013. ["Acoustic Blind Deconvolution and Unconventional Nonlinear Beamforming in Shallow Ocean Environments"](https://apps.dtic.mil/dtic/tr/fulltext/u2/a598859.pdf). MICHIGAN UNIV ANN ARBOR DEPT OF MECHANICAL ENGINEERING.

[4.2b]  Hossein Abadi, S., 2013. "Blind deconvolution in multipath environments and extensions to remote source localization", [paper](https://asa.scitation.org/doi/pdf/10.1121/1.3688502?class=pdf), [thesis](https://deepblue.lib.umich.edu/bitstream/handle/2027.42/102443/shimah_1.pdf?sequence=1&isAllowed=y).

### Contact or Tactile

[5.1]  Suresh, S., Bauza, M., Yu, K.T., Mangelson, J.G., Rodriguez, A. and Kaess, M., 2021, May. [Tactile SLAM: Real-time inference of shape and pose from planar pushing](https://dspace.mit.edu/bitstream/handle/1721.1/139635/2011.07044.pdf?sequence=2&isAllowed=y). In 2021 IEEE International Conference on Robotics and Automation (ICRA) (pp. 11322-11328). IEEE.
